import Listr from 'listr';
import { File, Reporter, RunnerContext, Task, ResolvedConfig } from '../types';
interface TaskPromise {
    promise: Promise<void>;
    resolve: () => void;
    reject: (e: unknown) => void;
}
export declare class DefaultReporter implements Reporter {
    start: number;
    end: number;
    listr: Listr | null;
    listrPromise: Promise<void> | null;
    taskMap: Map<Task, TaskPromise>;
    cwd: string;
    relative(path: string): string;
    onStart(config: ResolvedConfig): void;
    onCollected(files: File[]): void;
    onTaskEnd(task: Task): void;
    onFinished(ctx: RunnerContext, files?: File[]): Promise<void>;
    onWatcherStart(ctx: RunnerContext): Promise<void>;
    onWatcherRerun(files: string[], trigger: string): Promise<void>;
    onSnapshotUpdate(): void;
}
export {};
